package com.bmw.cascade.pruefstand.ediabas;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;
import javax.swing.text.JTextComponent;

public class EdiabasGUITool extends JFrame {
        public static ResourceBundle bundle;
        private String sgbd = "";
        private String job = "";
        private boolean DEBUG = false;
        
        public EdiabasGUITool( String title ) {
                super( title );
                setDefaultCloseOperation( HIDE_ON_CLOSE );
                getContentPane().add( getEdiabasPanel(), BorderLayout.NORTH );
        }

        private ActionListener actionListener;
        private ActionListener getActionListener() {
                if( actionListener == null ) {
                        actionListener = new ActionHandler();
                }
                return actionListener;
        }

        private JPanel ediabasPanel;
        private JPanel getEdiabasPanel() {
                if ( ediabasPanel == null ) {
                  ediabasPanel = new JPanel( new GridLayout( 4, 1 ) );
                  ediabasPanel.add( getSgbdPanel() );
                  ediabasPanel.add( getJobPanel() );
                  ediabasPanel.add( getParameterPanel() );
                  ediabasPanel.add( getResultsPanel() );
                }
                return ediabasPanel;
        }

        private JPanel sgbdPanel;
        private JPanel getSgbdPanel() {
                if( sgbdPanel == null ) {
                        sgbdPanel = new JPanel( new BorderLayout( 1, 2 ) );
                        sgbdPanel.add( getSgbdInputField(), BorderLayout.CENTER );
                        sgbdPanel.add( getSgbdCopyButton(), BorderLayout.EAST );
                        sgbdPanel.setBorder( new TitledBorder( "SGBD" ) );
                }
                return sgbdPanel;
        }
               
        private JPanel jobPanel;
        private JPanel getJobPanel() {
                if( jobPanel == null ) {
                        jobPanel = new JPanel( new BorderLayout( 1, 2 ) );
                        jobPanel.add( getJobInputField(), BorderLayout.CENTER );
                        jobPanel.add( getJobCopyButton(), BorderLayout.EAST );
                        jobPanel.setBorder( new TitledBorder( "Job" ) );
                }
                return jobPanel;
        }

        private JPanel parameterPanel;
        private JPanel getParameterPanel() {
                if( parameterPanel == null ) {
                        parameterPanel = new JPanel( new BorderLayout( 1, 2 ) );
                        parameterPanel.add( getParameterInputField(), BorderLayout.CENTER );
                        parameterPanel.add( getParameterCopyButton(), BorderLayout.EAST );
                        parameterPanel.setBorder( new TitledBorder( "Parameter" ) );
                }
                return parameterPanel;
        }

        private JPanel resultsPanel;
        private JPanel getResultsPanel() {
                if( resultsPanel == null ) {
                        resultsPanel = new JPanel( new BorderLayout( 1, 2 ) );
                        resultsPanel.add( getResultsInputField(), BorderLayout.CENTER );
                        resultsPanel.add( getResultCopyButton(), BorderLayout.EAST );
                        resultsPanel.setBorder( new TitledBorder( "Result" ) );
                }
                return resultsPanel;
        }

        private JComboBox sgbdInputField;
        private JComboBox getSgbdInputField() {
                if (jobInputField == null ) {
                  sgbdInputField = new JComboBox( getSgbdNames() );
                  sgbdInputField.setEditable( false );
                  sgbdInputField.addActionListener( getActionListener() );
                }
                return sgbdInputField;
        }

        private JComboBox jobInputField;
        private JComboBox getJobInputField() {
                if (jobInputField == null ) {
                  jobInputField = new JComboBox( new String[] { "" } );
                  jobInputField.setEditable( false );
                  jobInputField.addActionListener( getActionListener() );
                }
                return jobInputField;
        }

        private JComboBox parameterInputField;
        private JComboBox getParameterInputField() {
                if (parameterInputField == null ) {
                  parameterInputField = new JComboBox( new String[] { "" } );
                  parameterInputField.setEditable( false );
                }
                return parameterInputField;
        }

        private JComboBox resultsInputField;
        private JComboBox getResultsInputField() {
                if (resultsInputField == null ) {
                  resultsInputField = new JComboBox( new String[] { "" } );
                  resultsInputField.setEditable( false );
                }
                return resultsInputField;
        }

        private JButton sgbdCopyButton;
        private JButton getSgbdCopyButton() {
                if( sgbdCopyButton == null ) {
                  ImageIcon copyIcon = new ImageIcon("com/bmw/cascade/admingui/images/toolbar/copy.gif");
                  sgbdCopyButton = new JButton( "Copy",copyIcon );
                  sgbdCopyButton.addActionListener( getActionListener() );
                }
                return sgbdCopyButton;            
        }

        private JButton jobCopyButton;
        private JButton getJobCopyButton() {
                if( jobCopyButton == null ) {
                  ImageIcon copyIcon = new ImageIcon("com/bmw/cascade/admingui/images/toolbar/copy.gif");
                  jobCopyButton = new JButton( "Copy",copyIcon );
                  jobCopyButton.addActionListener( getActionListener() );
                }
                return jobCopyButton;            
        }

        private JButton parameterCopyButton;
        private JButton getParameterCopyButton() {
                if( parameterCopyButton == null ) {
                  ImageIcon copyIcon = new ImageIcon("com/bmw/cascade/admingui/images/toolbar/copy.gif");
                  parameterCopyButton = new JButton( "Copy",copyIcon );
                  parameterCopyButton.addActionListener( getActionListener() );
                }
                return parameterCopyButton;            
        }

        private JButton resultCopyButton;
        private JButton getResultCopyButton() {
                if( resultCopyButton == null ) {
                  ImageIcon copyIcon = new ImageIcon("com/bmw/cascade/admingui/images/toolbar/copy.gif");
                  resultCopyButton = new JButton( "Copy",copyIcon );
                  resultCopyButton.addActionListener( getActionListener() );
                }
                return resultCopyButton;            
        }

        private String[] getSgbdNames() {
                File ecuPath;
                try {
                  Ediabas.apiInit();
                  ecuPath = new File ( Ediabas.apiGetConfig("EcuPath") );
                  Ediabas.apiEnd();
                } catch (Exception e) {
                  return new String[] { "Unknown" };
                }
                return ecuPath.list(new MyFileFilter());
        }

        private void displayJobNames() {
                if (DEBUG) System.out.println("Jobs");
                jobInputField.removeAllItems();
                jobInputField.addItem("");
                try {
                  Ediabas.apiInit();
                  Ediabas.apiJob( sgbd, "_jobs", "", "" );
                  if (DEBUG) System.out.println(Ediabas.getResult().toString());
                  for (int i=1; i< Ediabas.getDiagJobSaetze(); i++) {
                    jobInputField.addItem(Ediabas.getDiagResultValue(i, "JOBNAME"));
                  }
                  Ediabas.apiEnd();
                } catch( Exception e ) {
                  jobInputField.addItem("ERROR");
                }
        }

        private void displayParameterNames() {
                if (DEBUG) System.out.println("Pars");
                parameterInputField.removeAllItems();
                try {
                  Ediabas.apiInit();
                  Ediabas.apiJob( sgbd, "_arguments", job, "" );
                  if (DEBUG) System.out.println(Ediabas.getResult().toString());
                  for (int i=1; i< Ediabas.getDiagJobSaetze(); i++) {
                    parameterInputField.addItem(Ediabas.getDiagResultValue(i, "ARG"));
                  }
                  Ediabas.apiEnd();
                } catch( Exception e ) {
                  parameterInputField.addItem("ERROR");
                }                                                                   
        }
                                                                                 
        private void displayResultNames() {
                if (DEBUG) System.out.println("Res");
                resultsInputField.removeAllItems();                                         
                try {
                  Ediabas.apiInit();
                  Ediabas.apiJob( sgbd, "_results", job, "" );
                  if (DEBUG) System.out.println(Ediabas.getResult().toString());
                  for (int i=1; i< Ediabas.getDiagJobSaetze(); i++) {
                    resultsInputField.addItem(Ediabas.getDiagResultValue(i, "RESULT"));
                  }
                  Ediabas.apiEnd();
                } catch( Exception e ) {
                  resultsInputField.addItem("ERROR");
                }
        }

        private class ActionHandler implements ActionListener {
                public void actionPerformed( ActionEvent e ) {
                   Object src = e.getSource();
                   if (src == sgbdInputField) {
                     String temp = sgbdInputField.getSelectedItem().toString();
                     sgbd = temp.substring(0, (temp.length()-4));                                      
                     displayJobNames();
                   } else if (src == jobInputField) {
                     try {                                                             
                       job = jobInputField.getSelectedItem().toString();
                     } catch (Exception exc) {                                                 
                     }
                     displayParameterNames();
                     displayResultNames();
                   } else if (src == sgbdCopyButton) {
                     if (DEBUG) System.out.println("Copy SGBD");
                     String sgbdName = (String) getSgbdInputField().getSelectedItem();
                     JTextField temp = new JTextField( sgbdName.substring(0, (sgbdName.length()-4)) );
                     temp.selectAll();
                     if (DEBUG) System.out.println("Copy SGBD: "+temp.getSelectedText());
                     temp.copy();
                   } else if (src == jobCopyButton) {
                     if (DEBUG) System.out.println("Copy JOB");
                     JTextField temp = new JTextField( (String) getJobInputField().getSelectedItem() );
                     temp.selectAll();
                     temp.copy();
                   } else if (src == parameterCopyButton) {
                     if (DEBUG) System.out.println("Copy PAR");                                      
                     JTextField temp = new JTextField( (String) getParameterInputField().getSelectedItem() );
                     temp.selectAll();
                     temp.copy();
                   } else if (src == resultCopyButton) {
                     if (DEBUG) System.out.println("Copy RESULT");                             
                     JTextField temp = new JTextField( (String) getResultsInputField().getSelectedItem() );
                     temp.selectAll();
                     temp.copy();
                   }
                }
        }      

        private class MyFileFilter implements FilenameFilter {
                public MyFileFilter() {
                }
    
                public boolean accept( File ecupath, String file ) {
                  if( !file.toLowerCase().endsWith( ".prg" ) ) return false;
                  return true;
                }
        }

        public static void main( String[] args ) {
                EdiabasGUITool jtool = new EdiabasGUITool( "Ediabas GUI Tool" );
                jtool.pack();
                jtool.setVisible( true );
        }
}
