package com.bmw.cascade.pruefstand.ediabas;

public class EdiabasResultLong extends EdiabasResultValue  {
	private String name;
	private long value;

	public EdiabasResultLong( String name, long value ) {
		super( name );
		this.value = value;
	}

	public String stringValue() {
		return String.valueOf( value );
	}
	public double doubleValue() {
		return (double)value;
	}
	public float floatValue() {
		return (float) value;
	}
	public int intValue() {
		if( value > Integer.MAX_VALUE || value < Integer.MIN_VALUE ) {
			throw new ArithmeticException();
		}
		return (int) value;
	}
	public short shortValue() {
		if( value > Short.MAX_VALUE || value < Short.MIN_VALUE ) {
			throw new ArithmeticException();
		}
		return (short) value;
	}
	public byte byteValue() {
		if( value > Byte.MAX_VALUE || value < Byte.MIN_VALUE ) {
			throw new ArithmeticException();
		}
		return (byte) value;
	}
}