package com.bmw.cascade.pruefstand.ediabas;

import java.util.*;

public class EdiabasResultSet extends Hashtable {
  public EdiabasResultSet( int numberOfResults ) {
    super( numberOfResults );
  }

  public Object put( EdiabasResultValue result ) {
    return this.put( result.getName(), result );
  }

  public Object put( Object key, Object value ) {
    if( !( key instanceof String ) ) {
      throw new IllegalArgumentException( "key is not instance of java.lang.String" );
    }
    if( !( value instanceof EdiabasResultValue ) ) {
      throw new IllegalArgumentException( "value has to be an instance of EdiabasResultValue" );
    }
    return super.put( key, value );
  }

  public EdiabasResultValue get( String key ) throws EdiabasResultNotFoundException {
    if( !containsKey(key) ) throw new EdiabasResultNotFoundException ("Result " + key + " not available");
    return (EdiabasResultValue) super.get( key );
  }
  public String toString() {
    StringBuffer buffer = new StringBuffer();
    Enumeration keys = keys();
    while( keys.hasMoreElements() ) {
      buffer.append( get( keys.nextElement() ) );
      buffer.append( "\n" /*System.getProperty( "line.separator" ) */ );
    }
    return buffer.toString();
  }
}